# coding: utf-8

"""
    Arduino IoT Cloud API

     Provides a set of endpoints to manage Arduino IoT Cloud **Devices**, **Things**, **Properties** and **Timeseries**. This API can be called just with any HTTP Client, or using one of these clients:  * [Javascript NPM package](https://www.npmjs.com/package/@arduino/arduino-iot-client)  * [Python PYPI Package](https://pypi.org/project/arduino-iot-client/)  * [Golang Module](https://github.com/arduino/iot-client-go)  # noqa: E501

    The version of the OpenAPI document: 2.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from arduino_iot_rest.configuration import Configuration


class ArduinoLorafreqplanv1(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'advanced': 'bool',
        'id': 'str',
        'name': 'str'
    }

    attribute_map = {
        'advanced': 'advanced',
        'id': 'id',
        'name': 'name'
    }

    def __init__(self, advanced=None, id=None, name=None, local_vars_configuration=None):  # noqa: E501
        """ArduinoLorafreqplanv1 - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._advanced = None
        self._id = None
        self._name = None
        self.discriminator = None

        self.advanced = advanced
        self.id = id
        self.name = name

    @property
    def advanced(self):
        """Gets the advanced of this ArduinoLorafreqplanv1.  # noqa: E501

        Frequency plan only for advanced users  # noqa: E501

        :return: The advanced of this ArduinoLorafreqplanv1.  # noqa: E501
        :rtype: bool
        """
        return self._advanced

    @advanced.setter
    def advanced(self, advanced):
        """Sets the advanced of this ArduinoLorafreqplanv1.

        Frequency plan only for advanced users  # noqa: E501

        :param advanced: The advanced of this ArduinoLorafreqplanv1.  # noqa: E501
        :type: bool
        """
        if self.local_vars_configuration.client_side_validation and advanced is None:  # noqa: E501
            raise ValueError("Invalid value for `advanced`, must not be `None`")  # noqa: E501

        self._advanced = advanced

    @property
    def id(self):
        """Gets the id of this ArduinoLorafreqplanv1.  # noqa: E501

        The ID of the frequency paln  # noqa: E501

        :return: The id of this ArduinoLorafreqplanv1.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ArduinoLorafreqplanv1.

        The ID of the frequency paln  # noqa: E501

        :param id: The id of this ArduinoLorafreqplanv1.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this ArduinoLorafreqplanv1.  # noqa: E501

        The name of the frequency plan  # noqa: E501

        :return: The name of this ArduinoLorafreqplanv1.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ArduinoLorafreqplanv1.

        The name of the frequency plan  # noqa: E501

        :param name: The name of this ArduinoLorafreqplanv1.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ArduinoLorafreqplanv1):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ArduinoLorafreqplanv1):
            return True

        return self.to_dict() != other.to_dict()
