# coding: utf-8

"""
    Arduino IoT Cloud API

     Provides a set of endpoints to manage Arduino IoT Cloud **Devices**, **Things**, **Properties** and **Timeseries**. This API can be called just with any HTTP Client, or using one of these clients:  * [Javascript NPM package](https://www.npmjs.com/package/@arduino/arduino-iot-client)  * [Python PYPI Package](https://pypi.org/project/arduino-iot-client/)  * [Golang Module](https://github.com/arduino/iot-client-go)  # noqa: E501

    The version of the OpenAPI document: 2.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from arduino_iot_rest.configuration import Configuration


class Devicev2Cert(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'ca': 'str',
        'csr': 'str',
        'enabled': 'bool'
    }

    attribute_map = {
        'ca': 'ca',
        'csr': 'csr',
        'enabled': 'enabled'
    }

    def __init__(self, ca=None, csr=None, enabled=None, local_vars_configuration=None):  # noqa: E501
        """Devicev2Cert - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._ca = None
        self._csr = None
        self._enabled = None
        self.discriminator = None

        if ca is not None:
            self.ca = ca
        if csr is not None:
            self.csr = csr
        if enabled is not None:
            self.enabled = enabled

    @property
    def ca(self):
        """Gets the ca of this Devicev2Cert.  # noqa: E501

        The Certification Authority you want to use  # noqa: E501

        :return: The ca of this Devicev2Cert.  # noqa: E501
        :rtype: str
        """
        return self._ca

    @ca.setter
    def ca(self, ca):
        """Sets the ca of this Devicev2Cert.

        The Certification Authority you want to use  # noqa: E501

        :param ca: The ca of this Devicev2Cert.  # noqa: E501
        :type: str
        """

        self._ca = ca

    @property
    def csr(self):
        """Gets the csr of this Devicev2Cert.  # noqa: E501

        The certificate request in pem format  # noqa: E501

        :return: The csr of this Devicev2Cert.  # noqa: E501
        :rtype: str
        """
        return self._csr

    @csr.setter
    def csr(self, csr):
        """Sets the csr of this Devicev2Cert.

        The certificate request in pem format  # noqa: E501

        :param csr: The csr of this Devicev2Cert.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                csr is not None and len(csr) > 1024):
            raise ValueError("Invalid value for `csr`, length must be less than or equal to `1024`")  # noqa: E501

        self._csr = csr

    @property
    def enabled(self):
        """Gets the enabled of this Devicev2Cert.  # noqa: E501

        Whether the certificate is enabled  # noqa: E501

        :return: The enabled of this Devicev2Cert.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this Devicev2Cert.

        Whether the certificate is enabled  # noqa: E501

        :param enabled: The enabled of this Devicev2Cert.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Devicev2Cert):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Devicev2Cert):
            return True

        return self.to_dict() != other.to_dict()
